package com.malk.ruisi.client;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @Description:
 * @Author: Z.M
 * @Date: 2024/1/5 10:22
 */

public class RefundEntry extends com.malk.ruisi.client.WSBean implements java.io.Serializable{

    /**
     * id
     */
    private Integer id;

    /**
     * 合同/异动/其他付款单编号
     */
    private String entityCode;

    /**
     * 合同/异动/其他付款单id
     */
    private Integer entityId;

    /**
     * 10-合同 ，20-其他付款单， 30-异动
     */
    private Integer entityType;

    /**
     * 付款计划id
     */
    private Integer paymentPlanId;

    /**
     * 退费b_contract_refund表id，other_refund表id
     */
    private Integer refundId;

    /**
     * 是否北银商原路退，1-是，0-否
     */
    private String isback;

    /**
     * 公司编码
     */
    private String company;

    /**
     * 业务日期
     */
    private String bizdate;

    /**
     * 收付类别,01-现金，02-银行存款
     */
    private String feetype;

    /**
     * 付款类型 999 其他
     */
    private String paybilltype;

    /**
     * 付款币别 RMB
     */
    private String currency;

    /**
     * 付款金额
     */
    private BigDecimal actpayamt;

    /**
     * 汇率 默认1
     */
    private BigDecimal exchangerate;

    /**
     * 稅率 默认1 税率
     */
    private BigDecimal cosfee;

    /**
     * 付款账户
     */
    private String payeraccountbank;

    /**
     * 结算方式 6-银企直联-跨行对私
     */
    private String settlementtype;

    /**
     * 摘要
     */
    private String cosdescription;

    /**
     * 收款人类型 其他
     */
    private String payeetype;


    /**
     * 收款人名称
     */
    private String payeename;

    /**
     * 收款账号
     */
    private String payeeaccountbank;

    /**
     * 收款银行
     */
    private String payeebank;

    /**
     * 用途
     */
    private String payreq;

    private String usage;

    /**
     * 收款人实名
     */
    private String bankacctname;

    /**
     * 收款行行号
     */
    private String banknumber;

    /**
     * 收款方省
     */
    private String recprovince;

    /**
     * 收款方市县
     */
    private String reccity;

    /**
     * 创建人
     */
    private String createdBy;



    /**
     * 创建时间
     */
    private Date createdTime;

    /**
     * 更新人
     */
    private String updatedBy;

    /**
     * 更新时间
     */
    private Date updatedTime;

    public RefundEntry() {

    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getEntityCode() {
        return entityCode;
    }

    public void setEntityCode(String entityCode) {
        this.entityCode = entityCode;
    }

    public Integer getEntityId() {
        return entityId;
    }

    public void setEntityId(Integer entityId) {
        this.entityId = entityId;
    }

    public Integer getEntityType() {
        return entityType;
    }

    public void setEntityType(Integer entityType) {
        this.entityType = entityType;
    }

    public Integer getPaymentPlanId() {
        return paymentPlanId;
    }

    public void setPaymentPlanId(Integer paymentPlanId) {
        this.paymentPlanId = paymentPlanId;
    }

    public Integer getRefundId() {
        return refundId;
    }

    public void setRefundId(Integer refundId) {
        this.refundId = refundId;
    }

    public String getIsback() {
        return isback;
    }

    public void setIsback(String isback) {
        this.isback = isback;
    }

    public String getCompany() {
        return company;
    }

    public void setCompany(String company) {
        this.company = company;
    }

    public String getBizdate() {
        return bizdate;
    }

    public void setBizdate(String bizdate) {
        this.bizdate = bizdate;
    }

    public String getFeetype() {
        return feetype;
    }

    public void setFeetype(String feetype) {
        this.feetype = feetype;
    }

    public String getPaybilltype() {
        return paybilltype;
    }

    public void setPaybilltype(String paybilltype) {
        this.paybilltype = paybilltype;
    }

    public String getCurrency() {
        return currency;
    }

    public void setCurrency(String currency) {
        this.currency = currency;
    }

    public BigDecimal getActpayamt() {
        return actpayamt;
    }

    public void setActpayamt(BigDecimal actpayamt) {
        this.actpayamt = actpayamt;
    }

    public BigDecimal getExchangerate() {
        return exchangerate;
    }

    public void setExchangerate(BigDecimal exchangerate) {
        this.exchangerate = exchangerate;
    }

    public BigDecimal getCosfee() {
        return cosfee;
    }

    public void setCosfee(BigDecimal cosfee) {
        this.cosfee = cosfee;
    }

    public String getPayeraccountbank() {
        return payeraccountbank;
    }

    public void setPayeraccountbank(String payeraccountbank) {
        this.payeraccountbank = payeraccountbank;
    }

    public String getSettlementtype() {
        return settlementtype;
    }

    public void setSettlementtype(String settlementtype) {
        this.settlementtype = settlementtype;
    }

    public String getCosdescription() {
        return cosdescription;
    }

    public void setCosdescription(String cosdescription) {
        this.cosdescription = cosdescription;
    }

    public String getPayeetype() {
        return payeetype;
    }

    public void setPayeetype(String payeetype) {
        this.payeetype = payeetype;
    }

    public String getPayeename() {
        return payeename;
    }

    public void setPayeename(String payeename) {
        this.payeename = payeename;
    }

    public String getPayeeaccountbank() {
        return payeeaccountbank;
    }

    public void setPayeeaccountbank(String payeeaccountbank) {
        this.payeeaccountbank = payeeaccountbank;
    }

    public String getPayeebank() {
        return payeebank;
    }

    public void setPayeebank(String payeebank) {
        this.payeebank = payeebank;
    }

    public String getPayreq() {
        return payreq;
    }

    public void setPayreq(String payreq) {
        this.payreq = payreq;
    }

    public String getUsage() {
        return usage;
    }

    public void setUsage(String usage) {
        this.usage = usage;
    }

    public String getBankacctname() {
        return bankacctname;
    }

    public void setBankacctname(String bankacctname) {
        this.bankacctname = bankacctname;
    }

    public String getBanknumber() {
        return banknumber;
    }

    public void setBanknumber(String banknumber) {
        this.banknumber = banknumber;
    }

    public String getRecprovince() {
        return recprovince;
    }

    public void setRecprovince(String recprovince) {
        this.recprovince = recprovince;
    }

    public String getReccity() {
        return reccity;
    }

    public void setReccity(String reccity) {
        this.reccity = reccity;
    }

    public String getCreatedBy() {
        return createdBy;
    }

    public void setCreatedBy(String createdBy) {
        this.createdBy = createdBy;
    }

    public Date getCreatedTime() {
        return createdTime;
    }

    public void setCreatedTime(Date createdTime) {
        this.createdTime = createdTime;
    }

    public String getUpdatedBy() {
        return updatedBy;
    }

    public void setUpdatedBy(String updatedBy) {
        this.updatedBy = updatedBy;
    }

    public Date getUpdatedTime() {
        return updatedTime;
    }

    public void setUpdatedTime(Date updatedTime) {
        this.updatedTime = updatedTime;
    }

    public RefundEntry(Integer id, String entityCode, Integer entityId, Integer entityType, Integer paymentPlanId, Integer refundId, String isback, String company, String bizdate, String feetype, String paybilltype, String currency, BigDecimal actpayamt, BigDecimal exchangerate, BigDecimal cosfee, String payeraccountbank, String settlementtype, String cosdescription, String payeetype, String payeename, String payeeaccountbank, String payeebank, String payreq, String usage, String bankacctname, String banknumber, String recprovince, String reccity, String createdBy, Date createdTime, String updatedBy, Date updatedTime) {
        this.id = id;
        this.entityCode = entityCode;
        this.entityId = entityId;
        this.entityType = entityType;
        this.paymentPlanId = paymentPlanId;
        this.refundId = refundId;
        this.isback = isback;
        this.company = company;
        this.bizdate = bizdate;
        this.feetype = feetype;
        this.paybilltype = paybilltype;
        this.currency = currency;
        this.actpayamt = actpayamt;
        this.exchangerate = exchangerate;
        this.cosfee = cosfee;
        this.payeraccountbank = payeraccountbank;
        this.settlementtype = settlementtype;
        this.cosdescription = cosdescription;
        this.payeetype = payeetype;
        this.payeename = payeename;
        this.payeeaccountbank = payeeaccountbank;
        this.payeebank = payeebank;
        this.payreq = payreq;
        this.usage = usage;
        this.bankacctname = bankacctname;
        this.banknumber = banknumber;
        this.recprovince = recprovince;
        this.reccity = reccity;
        this.createdBy = createdBy;
        this.createdTime = createdTime;
        this.updatedBy = updatedBy;
        this.updatedTime = updatedTime;
    }
}
