package com.malk.ruisi.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.malk.ruisi.client.WSContext;
import com.malk.ruisi.service.ActivityProjectService;
import com.malk.ruisi.services.EASLogin.EASLoginProxyProxy;
import com.malk.ruisi.services.WSPortalMainFacade.WSPortalMainFacadeSrvProxyProxy;
import com.malk.server.aliwork.YDConf;
import com.malk.server.aliwork.YDParam;
import com.malk.server.common.McR;
import com.malk.server.dingtalk.DDConf;
import com.malk.service.aliwork.YDClient;
import com.malk.utils.UtilMap;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.SneakyThrows;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.*;

@Slf4j
@Service
public class ActivityProjectServiceImpl implements ActivityProjectService {
    @Autowired
    private YDClient ydClient;
    @Autowired
    private YDConf ydConf;
    @Autowired
    private DDConf ddConf;
    @SneakyThrows
    @Override
    public McR addActivity(String instanceId) {
        if(instanceId != null){
            System.out.println("表单实例ID："+instanceId);
            Map data = (Map) ydClient.queryData(YDParam.builder().formInstId(instanceId)
                    .appType(ydConf.getAppType()).systemToken(ydConf.getSystemToken())
                    .userId(ddConf.getOperator()).build(), YDConf.FORM_QUERY.retrieve_id).getFormData();
            System.out.println(data);
            //项目名称
            String name = data.get("textField_lx9qwfan").toString();
            String Actname = null;
            int startIndex1 = name.indexOf("\"") + 1; // 找到第一个双引号后的位置
            int endIndex1 = name.lastIndexOf("\""); // 找到最后一个双引号的位置
            if (startIndex1 > 0 && endIndex1 > startIndex1) {
                Actname = name.substring(startIndex1, endIndex1);
            }
            //项目编号
            String Actnum = null;
            String number = data.get("textField_lx9qwfas").toString();
            int startIndex2 = number.indexOf("\"") + 1; // 找到第一个双引号后的位置
            int endIndex2 = number.lastIndexOf("\""); // 找到最后一个双引号的位置
            if (startIndex2 > 0 && endIndex2 > startIndex2) {
                Actnum = number.substring(startIndex2, endIndex2);
            }
            //描述
            String discption = data.get("textField_lx9qwfat").toString();
            String disc = null;
            int startIndex3 = discption.indexOf("\"") + 1; // 找到第一个双引号后的位置
            int endIndex3 = discption.lastIndexOf("\""); // 找到最后一个双引号的位置
            if (startIndex3 > 0 && endIndex3 > startIndex3) {
                disc = discption.substring(startIndex3, endIndex3);
            }
            

            //创建并填充数据：流水号-流水号  编码-项目编码  名称-项目名称  描述-描述
            DataItem item =
                    new DataItem(data.get("serialNumberField_lucci16z").toString(),Actnum, Actname, disc);
            //创建外层对象并设置数据
            RequestData requestData = new RequestData();
            requestData.setType("PR01");
            requestData.setData(new DataItem[]{item});
            String datasource = requestData.toString();
            //打印JSON
            System.out.println(datasource);
            //调先登录金蝶
            EASLoginProxyProxy login = new EASLoginProxyProxy();
            WSContext ctx = login.login("748", "riverdeepqwer12", "eas", "river001",
                    "L2", 2);
            System.out.println(ctx);
            if (null != ctx.getSessionId() && !"".equals(ctx.getSessionId())) {
                System.out.println("ctx.getSessionId():" + ctx.getSessionId());
                WSPortalMainFacadeSrvProxyProxy portal = new WSPortalMainFacadeSrvProxyProxy();

                String remsg = portal.portalToEas("PR01", datasource);
                System.out.println("remsg:"+remsg);
            }

            //项目基本信息基础档案数据新增
            //项目编号 项目名称 描述
            String sc = "textField_lu7rme31, textField_lu7rme3a, textField_lu7rme3o";
            ydClient.operateData(YDParam.builder()
                    .formUuid("FORM-AD716D5C719B4EA18D3086F0EE2C2537JETI")
                    .searchCondition(JSONObject.toJSONString(UtilMap.map("textField_lu7rme31",Actnum)))
                    .formDataJson(JSONObject.toJSONString(UtilMap.map(sc,Actnum,Actname,disc)))
                    .build(),YDConf.FORM_OPERATION.upsert).toString();
        }
        return McR.success();
    }


    /*用于抓取活动项目信息*/
    public void Activity(){
        //1、数据库
        List<Map> activityList = new ArrayList<>();
        String sql = "SELECT id,xmbh,xmmc,miao,xmlx,zt  FROM uf_xmjbxx where zt!=1";
        String jdbcUrl = "jdbc:mysql://10.19.3.91:44071/ecology";
        String userName = "root";
        String password = "Portal_master_db002";
        try{
            Class.forName("com.mysql.cj.jdbc.Driver");
            Connection conn = DriverManager.getConnection(jdbcUrl, userName, password);
            Statement statement = conn.createStatement();
            ResultSet resultSet = statement.executeQuery(sql);
            int i=0;
            while (resultSet.next()){
                i++;
                System.out.println(i+"-"+resultSet.getFetchSize());
                System.out.println(resultSet.getString("id"));

                String fid = resultSet.getString("id");//主键id
                String xmbh = resultSet.getString("xmbh");//项目编号
                String xmmc = resultSet.getString("xmmc");//项目名称
                String miao = resultSet.getString("miao");//描述
                String xmlx = resultSet.getString("xmlx");//项目类型
//                String fisenabled = Objects.equals(resultSet.getString("FISENABLED"), "1") ?"是":"否";//是否启用：1-启用   0-不启用
                HashMap<String, Object> activitymap = new HashMap<>();
//                activitymap.put("id",fid);
                activitymap.put("xmbh",xmbh);
                activitymap.put("xmmc",xmmc);
                activitymap.put("miao",miao);
                activitymap.put("xmlx",xmlx);
//                activitymap.put("FISENABLED",fisenabled);
                activityList.add(activitymap);
            }
            resultSet.close();
            statement.close();
            conn.close();

        }catch (Exception e){
            e.printStackTrace();
        }


        //2、操作数据
        for (Map activity : activityList) {
            log.info("activity:{}",activity);
            //项目编号  项目名称  描述   项目类型
            String sc = "textField_lu7rme31, textField_lu7rme3a, textField_lu7rme3o, textField_lu7rme3k";
            String id = (String) activity.get("id")!= null?(String) activity.get("id"):"数据库此字段为空";//唯一标识
            String xmbh = (String) activity.get("xmbh")!= null?(String) activity.get("xmbh"):"数据库此字段为空";
            String xmmc = (String) activity.get("xmmc") != null?(String) activity.get("xmmc"):"数据库此字段为空";
//            String fisenabled = (String) activity.get("FISENABLED") != null?(String) activity.get("FISENABLED"):"数据库此字段为空";
            String miao = activity.get("miao") != null ? (String) activity.get("miao") : "数据库此字段为空";
            String xmlx = activity.get("xmlx") != null ? (String) activity.get("xmlx") : "数据库此字段为空";
            /*List<Map> list=(List<Map>) ydClient.operateData(YDParam.builder()
                    .formUuid("FORM-AD716D5C719B4EA18D3086F0EE2C2537JETI")
                    .formDataJson(JSONObject.toJSONString(UtilMap.map("textField_lu7rme31, textField_lu7rme3a, textField_lu7rme3l",activity.get("FNUMBER"),activity.get("FNAME_L2"),activity.get("FISENABLED"))))
                    .searchCondition(JSONObject.toJSONString(UtilMap.map("textField_lu7rme31, textField_lu7rme3a, textField_lu7rme3l",activity.get("FNUMBER"),activity.get("FNAME_L2"),activity.get("FISENABLED")))
                            ., YDConf.FORM_OPERATION.upsert).toString());*/
            String string = ydClient.operateData(YDParam.builder()
                    .formUuid("FORM-AD716D5C719B4EA18D3086F0EE2C2537JETI")
                    .searchCondition(JSONObject.toJSONString(UtilMap.map("textField_lw5tg4e5",id)))
                    .formDataJson(JSONObject.toJSONString(UtilMap.map(sc, xmbh, xmmc, miao, xmlx)))
                    .build(), YDConf.FORM_OPERATION.upsert).toString();
            System.out.println("数据："+string);

            /*String s = convertToJson( activity.get("FNUMBER")!= null?activity.get("FNUMBER").toString() : "",
                    activity.get("FNAME_L2")!= null?activity.get("FNAME_L2").toString() : "",
                    activity.get("FISENABLED") != null ? activity.get("FISENABLED").toString(): "");
            if(list!=null && !list.isEmpty()){
                ydClient.operateData(YDParam.builder().formInstanceId(list.get(0).get("formInstanceId").toString()).updateFormDataJson(s).build(), YDConf.FORM_OPERATION.update);
            }else{
                ydClient.operateData(
                        YDParam.builder().formUuid("FORM-AD716D5C719B4EA18D3086F0EE2C2537JETI").formDataJson(s).build(), YDConf.FORM_OPERATION.create);
            }*/
        }
    }

    /*字段封装方法*/
    public static String convertToJson(String fnumber, String xmmc,String fisenabled) {
        // 创建一个JSONObject来保存数据
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("textField_lu7rme31", fnumber);
        jsonObject.put("textField_lu7rme3a", xmmc);
        jsonObject.put("textField_lu7rme3l",fisenabled);

        // 将JSONObject转换为JSON字符串
        String jsonString = jsonObject.toString();

        // 返回JSON字符串
        return jsonString;
    }

    //外层数据类
    @AllArgsConstructor
    @NoArgsConstructor
    @Data
    public static class RequestData{
        private String type;
        private DataItem[] data;

        @Override
        public String toString() {
            try {
                ObjectMapper mapper = new ObjectMapper();
                return mapper.writeValueAsString(this);
            } catch (IOException e) {
                e.printStackTrace();
                return "Error serializing to JSON";
            }
        }
    }

    //内部数据类
    @AllArgsConstructor
    @NoArgsConstructor
    @Data
    public static class DataItem{
        private String seqNum;//流水号
        private String number;//编码
        private String name;//名称
        private String description;//描述
    }

}


