package com.malk.ruisi.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.malk.ruisi.service.CostCenterService;
import com.malk.server.aliwork.YDConf;
import com.malk.server.aliwork.YDParam;
import com.malk.service.aliwork.YDClient;
import com.malk.utils.UtilMap;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.Statement;
import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
@Slf4j
public class CostCenterServiceImpl implements CostCenterService {
    @Autowired
    private YDClient ydClient;

    @Override
    public void CostCenter() {
        //1、数据库
        List<Map> costcenterList = new ArrayList<>();

        /*获取当前年-月-日*/
        LocalDate currentDate = LocalDate.now();
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd");
        String formattedDate = currentDate.format(formatter);
        // 原始SQL模板，使用占位符替代具体日期
        String sql  = "SELECT COSTCENTERNO,COSTCENTERNAME FROM T_COMPANYRELATION_VIEW WHERE COSTCENTERNAME NOT LIKE 'rise1%' "
                + "AND EXPIREDDATE>= TO_DATE('"+formattedDate+"','yyyy-MM-dd') AND EFFECTIVEDATE<= TO_DATE('"+formattedDate+"','yyyy-MM-dd') "
                + "GROUP BY COSTCENTERNO,COSTCENTERNAME ORDER BY COSTCENTERNAME";

        String jdbcUrl = "jdbc:oracle:thin:@10.30.53.26:1521:orcldb";
        String userName = "riverdeep86";
        String password = "riverdeep86";
        try{
            Class.forName("oracle.jdbc.driver.OracleDriver");
            Connection conn = DriverManager.getConnection(jdbcUrl, userName, password);
            Statement statement = conn.createStatement();
            ResultSet resultSet = statement.executeQuery(sql);
            int i=0;
            while (resultSet.next()) {
                i++;
                System.out.println(i + "-" + resultSet.getFetchSize());
                System.out.println(resultSet.getString("COSTCENTERNO"));

                String cbzxbm = resultSet.getString("COSTCENTERNO");//成本中心编码
                String cbzxmc = resultSet.getString("COSTCENTERNAME");//成本中心名称

                HashMap<String, Object> costmap = new HashMap<>();
                costmap.put("COSTCENTERNO", cbzxbm);
                costmap.put("COSTCENTERNAME", cbzxmc);
                costcenterList.add(costmap);
            }
            resultSet.close();
            statement.close();
            conn.close();
        }catch (Exception e){
            e.printStackTrace();
        }
        //异常处理集合
        ArrayList<Object> list1 = new ArrayList<>();
        int i =0;
        //2、操作数据
        for (Map cost : costcenterList) {
            i++;
            log.info("{}/{}",i,costcenterList.size());
            String sc = "textField_lu849afg, textField_lu849afh";
            String cbzxbm = cost.get("COSTCENTERNO")!= null?cost.get("COSTCENTERNO").toString():"数据库此字段为空";//成本中心编码
            String cbzxmc = cost.get("COSTCENTERNAME")!= null?cost.get("COSTCENTERNAME").toString():"数据库此字段为空";//成本中心名称
            try{
                String string = ydClient.operateData(YDParam.builder()
                        .formUuid("FORM-814D1D64E7904473AD250E8C3CEBC248ZKFT")
                        .searchCondition(JSONObject.toJSONString(UtilMap.map("textField_lu849afh", cbzxmc)))
                        .formDataJson(JSONObject.toJSONString(UtilMap.map(sc, cbzxbm, cbzxmc)))
                        .build(), YDConf.FORM_OPERATION.upsert).toString();
                System.out.println("数据："+string);
            }catch (Exception e){
                //异常处理
                e.printStackTrace();
                log.info("cost{}",cost);
                list1.add(cost);//存放错误数据
            }
        }
        log.info("异常数据集合:{}",list1);
    }

    public static String convertToJson(String id, String fnumber, String fname, String parentid,String parentno,String parentname,String flevel,
            String companyid,String companyno,String companyname,String issealup,String altertime) {
        // 创建一个JSONObject来保存数据
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("textField_lvrqkou4", id);
        jsonObject.put("textField_lu849afg", fnumber);
        jsonObject.put("textField_lu849afh", fname);
        jsonObject.put("textField_lvrqkou5", parentid);
        jsonObject.put("textField_lvrqkou6", parentno);
        jsonObject.put("textField_lvrqkou7", parentname);
        jsonObject.put("textField_lvrqkou8", flevel);
        jsonObject.put("textField_lvrqkou9", companyid);
        jsonObject.put("textField_lvrqkoua", companyno);
        jsonObject.put("textField_lvrqkoub", companyname);
        jsonObject.put("textField_lvrqkouc", issealup);
        jsonObject.put("textField_lvrqkoud", altertime);

        // 将JSONObject转换为JSON字符串
        String jsonString = jsonObject.toString();

        // 返回JSON字符串
        return jsonString;
    }
}