package com.malk.ruisi.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.malk.ruisi.service.MaterialService;
import com.malk.server.aliwork.YDConf;
import com.malk.server.aliwork.YDParam;
import com.malk.server.common.McR;
import com.malk.server.dingtalk.DDConf;
import com.malk.service.aliwork.YDClient;
import com.malk.utils.UtilMap;
import lombok.SneakyThrows;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Slf4j
@Service
public class MaterialServiceImpl implements MaterialService{
    @Autowired
    private YDConf ydConf;
    @Autowired
    private YDClient ydClient;
    @Autowired
    private DDConf ddConf;

    @SneakyThrows
    @Override
    public McR findMaterial(String formUuid){
        //分页查询，数据大于100
        String instanceId = "FORM-AFC00FB98917492B9B094B0A1856C7FAI9BZ";
        YDParam ydParam = YDParam.builder().formUuid(instanceId).build();
        ydParam.setPageSize(1);
        long totalCount = ydClient.queryData(ydParam, YDConf.FORM_QUERY.retrieve_search_form).getTotalCount();

        List<Map> dataList = new ArrayList<>();
        ydParam.setCurrentPage(1);
        ydParam.setPageSize(100);
        for (int page = 1; page <= (Math.ceil(totalCount / 100)!=0?Math.ceil(totalCount / 100):1); page++) {
            ydParam.setCurrentPage(page);
            dataList.addAll((List<Map>) ydClient.queryData(ydParam, YDConf.FORM_QUERY.retrieve_search_form).getData());
        }
        //对分页查询的数据业务处理
        for(Map li: dataList){
            String currentInstanceId = (String) li.get("formInstanceId");

            Map map = (Map) li.get("formData");
            String gysName= (String) map.get("textField_lw764w9i");
//            System.out.println("供应商："+gysName);


                //供应商
                List<Map>  supplierList= (List<Map>) ydClient.queryData(YDParam.builder().formUuid("FORM-11DE806A1543428FA9C18B5EED133779QUFD")
                        .appType(ydConf.getAppType()).systemToken(ydConf.getSystemToken())
                        .searchFieldJson(JSONObject.toJSONString(UtilMap.map("textField_lu248b7c",gysName)))
                        .userId(ddConf.getOperator()).build(), YDConf.FORM_QUERY.retrieve_list).getData();
                if(supplierList.size() >0 ){
                    Map map1 = (Map) supplierList.get(0);

                    String uuId = (String) map1.get("formInstanceId");

                    Map hashMap = new HashMap();
                    hashMap.put("associationFormField_lu24gdvc",YDConf.associationForm(ydConf.getAppType(),"FORM-11DE806A1543428FA9C18B5EED133779QUFD",
                            uuId,gysName,"",false));
                    if (!gysName.isEmpty()){
                        ydClient.operateData(YDParam.builder()
                                .formInstanceId(currentInstanceId)
                                .updateFormDataJson(JSON.toJSONString(hashMap))
                                .build(), YDConf.FORM_OPERATION.update);
                    }

                }
        }
        System.out.println("数据操作成功！");
        return McR.success();
    }

}
