package com.malk.ruisi.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.malk.ruisi.client.WSContext;
import com.malk.ruisi.entity.NewsSupplier;
import com.malk.ruisi.service.NewSupplierAdditionService;
import com.malk.ruisi.services.EASLogin.EASLoginProxyProxy;
import com.malk.ruisi.services.WSPortalMainFacade.WSPortalMainFacadeSrvProxyProxy;
import com.malk.server.aliwork.YDConf;
import com.malk.server.aliwork.YDParam;
import com.malk.server.common.McR;
import com.malk.server.common.McREnum;
import com.malk.server.dingtalk.DDConf;
import com.malk.service.aliwork.YDClient;
import com.malk.utils.UtilMap;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.SneakyThrows;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Slf4j
@Service
public class NewsSupplierAdditionServiceImpl implements NewSupplierAdditionService {
    @Autowired
    private YDClient ydClient;
    @Autowired
    private YDConf ydConf;
    @Autowired
    private DDConf ddConf;

    @SneakyThrows
    @Override
    public McR addAndUpdate(String instanceId) throws JsonProcessingException {
        if(instanceId != null){
            System.out.println("实例ID："+instanceId);
            /*流程表单字段信息*/
            Map data = (Map) ydClient.queryData(YDParam.builder().formInstId(instanceId)
                    .appType(ydConf.getAppType()).systemToken(ydConf.getSystemToken())
                    .userId(ddConf.getOperator()).build(), YDConf.FORM_QUERY.retrieve_id).getFormData();
            System.out.println(data);
            /*类型做判断：新增（更新基础表并且对接EAS）----更新（只更新基础表不对接EAS）*/
            if(data.get("selectField_luchp1e8").equals("新增")){
                /*宜搭供应商编码命名规则：GYS202403290001，后面的四位数会依次增加*/
                String number = data.get("serialNumberField_luchp1e2").toString();//number:流水号
                String name = data.get("textField_lug9nktw").toString();//name：公司名称
                String abbr = data.get("textField_lug9nktw").toString();//abbr：简称
                DataItem item = new DataItem(number, name, abbr, "2");//classifyNo供应商分类编码，固定传2
                RequestData requestData = new RequestData();
                requestData.setType("SU01");
                requestData.setData(new DataItem[]{item});
                System.out.println(requestData.toString());//输出传参json
                EASLoginProxyProxy login = new EASLoginProxyProxy();
                WSContext ctx = login.login("748", "riverdeepqwer12", "eas", "river001",
                        "L2", 2);
                System.out.println(ctx);
                if (null != ctx.getSessionId() && !"".equals(ctx.getSessionId())) {
                    System.out.println("ctx.getSessionId():" + ctx.getSessionId());
                    WSPortalMainFacadeSrvProxyProxy portal = new WSPortalMainFacadeSrvProxyProxy();

                    String remsg = portal.portalToEas("SU01", requestData.toString());
                    System.out.println("remsg:"+remsg);
                }

                //供应商基础档案表单数据新增
                String sc="textField_lu248b7c, textField_lvjbkqxl, textField_lu248b7w, textField_lu248b85, textField_lu248b86, textField_lu248b8f, textField_lw6a4tne, textField_lw6a4tnf, textField_lw6a4tng";
                String sc1="textField_lu248b7c, textField_lvjbkqxl, textField_lu248b7w, textField_lu248b85, textField_lu248b86, textField_lu248b8f, textField_lw6a4tne, textField_lw6a4tng";
                //供应商名称 供应商编码 户名 开户银行 账号 银行联行行号 收款方国家 收款方省 收款方市县
                String account = (String) data.get("textField_lug9nktx");//户名
                String accountBank = (String) data.get("textField_lug9nku0");//开户银行
                String accountID = (String) data.get("textField_lug9nkty");//账号
                String BIN = (String) data.get("textField_lw7x4em5");//银行联行行号
                ObjectMapper mapper = new ObjectMapper();

                System.out.println(data.get("countrySelectField_lupb9rhd"));
                String string = data.get("countrySelectField_lupb9rhd").toString();
                JsonNode rootNode = mapper.readTree(string);
                String country = rootNode.get(0).asText();//收款方国家
                String city = (String) data.get("textField_lw6b3vjv");//收款方市县
                /*是否境外公司*/
                if(data.get("selectField_luchp1e9").equals("否")){
                    String zhCN = null;
                    System.out.println(data.get("addressField_lupb9rhf"));;//有收款方省市
                    String jsonString = data.get("addressField_lupb9rhf").toString();
                    ObjectMapper objectMapper = new ObjectMapper();
                    JsonNode jsonNode = objectMapper.readTree(jsonString);
                    JsonNode regionTextArray  = jsonNode.get("regionText");
                    if (regionTextArray.isArray() && !regionTextArray.isEmpty()) {
                        JsonNode regionTextObject = regionTextArray.get(0);
                        zhCN = regionTextObject.get("zh_CN").asText();
                        System.out.println(zhCN);
                    }
                    String province = zhCN;//收款方省市
                    ydClient.operateData(YDParam.builder()
                            .formUuid("FORM-11DE806A1543428FA9C18B5EED133779QUFD")
                            .formDataJson(JSONObject.toJSONString(UtilMap.map(sc,name, number,account,accountBank,accountID,BIN,country,province,city)))
                            .build(), YDConf.FORM_OPERATION.create).toString();
                }else {
                    //没有收款方省市
                    ydClient.operateData(YDParam.builder()
                            .formUuid("FORM-11DE806A1543428FA9C18B5EED133779QUFD")
                            .formDataJson(JSONObject.toJSONString(UtilMap.map(sc1,name, number,account,accountBank,accountID,BIN,country,city)))
                            .build(), YDConf.FORM_OPERATION.create).toString();
                }

            }else {
                //户名 开户银行 账号 收款行国家 收款行省 收款行市县
                String so = "textField_lu248b7w, textField_lu248b85, textField_lu248b86, textField_lw6a4tne, textField_lw6a4tnf, textField_lw6a4tng";
                //户名 开户银行 账号 收款行国家 收款行市县
                String so1 = "textField_lu248b7w, textField_lu248b85, textField_lu248b86, textField_lw6a4tne, textField_lw6a4tng";
                String account = (String) data.get("textField_lug9nktx");//户名
                String accountBank = (String) data.get("textField_lug9nku0");//开户银行
                String accountID = (String) data.get("textField_lug9nkty");//账号
                String string = data.get("countrySelectField_lupb9rhd").toString();
                ObjectMapper mapper = new ObjectMapper();
                JsonNode rootNode = mapper.readTree(string);
                String country = rootNode.get(0).asText();//收款方国家
                String city = (String) data.get("textField_lw6b3vjv");//收款方市县
                String gysNo = data.get("textField_lx31ubkq").toString();//供应商编码
                /*是否境外公司*/
                if(data.get("selectField_luchp1e9").equals("否")){
                    String zhCN = null;
                    System.out.println(data.get("addressField_lupb9rhf"));;//有收款方省市
                    String jsonString = data.get("addressField_lupb9rhf").toString();
                    ObjectMapper objectMapper = new ObjectMapper();
                    JsonNode jsonNode = objectMapper.readTree(jsonString);
                    JsonNode regionTextArray  = jsonNode.get("regionText");
                    if (regionTextArray.isArray() && !regionTextArray.isEmpty()) {
                        JsonNode regionTextObject = regionTextArray.get(0);
                        zhCN = regionTextObject.get("zh_CN").asText();
                        System.out.println(zhCN);
                    }
                    String province = zhCN;//收款方省市

                    ydClient.operateData(YDParam.builder()
                            .formUuid("FORM-11DE806A1543428FA9C18B5EED133779QUFD")
                            .searchCondition(JSONObject.toJSONString(UtilMap.map("textField_lvjbkqxl",gysNo)))
                            .formDataJson(JSONObject.toJSONString(UtilMap.map(so,account,accountBank,accountID,country,province,city)))
                            .build(),YDConf.FORM_OPERATION.upsert).toString();
                }else {
                    //没有收款方省市
                    ydClient.operateData(YDParam.builder()
                            .formUuid("FORM-11DE806A1543428FA9C18B5EED133779QUFD")
                            .searchCondition(JSONObject.toJSONString(UtilMap.map("textField_lvjbkqxl",gysNo)))
                            .formDataJson(JSONObject.toJSONString(UtilMap.map(so1,account,accountBank,accountID,country,city)))
                            .build(), YDConf.FORM_OPERATION.upsert).toString();
                }

            }

        }else {
            return McR.error(McREnum.UNKNOWN_EXCEPTION.toString(),"参数未知");
        }
        return null;
    }



    //外层数据类
    @AllArgsConstructor
    @NoArgsConstructor
    @Data
    public static class RequestData{
        private String type;
        private NewsSupplierAdditionServiceImpl.DataItem[] data;

        @Override
        public String toString() {
            try {
                ObjectMapper mapper = new ObjectMapper();
                return mapper.writeValueAsString(this);
            } catch (IOException e) {
                e.printStackTrace();
                return "Error serializing to JSON";
            }
        }
    }

    //内部数据类
    @AllArgsConstructor
    @NoArgsConstructor
    @Data
    public static class DataItem{
        private String number;
        private String name;
        private String abbr;
        private String classifyNo;//固定传2
    }

}
