package com.malk.ruisi.utils;

import cn.hutool.core.codec.Base64;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;

/**
 * 通用接口工具类
 * @author 代文伟
 *
 */
public class InterfaceClientUtil {
	/**
	 * 拼装erp系统报文开头 oracle
	 */
	public static final String erp_xml_request_start="<Input xmlns:ns=\"http://xmlns.oracle.com/apps/cux/soaprovider/plsql/rest/Scux_Soa_Data_Transfer_Pkg1/\">" +
			" <ns1:RESTHeader xmlns:ns1=\"http://xmlns.oracle.com/apps/cux/soaprovider/plsql/rest/Scux_Soa_Data_Transfer_Pkg1/\"> " +
			" <ns1:Responsibility>SCUX_INTERFACE_SUPERUSER</ns1:Responsibility> " +
			" <ns1:RespApplication>SCUX</ns1:RespApplication>" +
			" <ns1:SecurityGroup>STANDARD</ns1:SecurityGroup> " +
			" <ns1:NLSLanguage>AMERICAN</ns1:NLSLanguage> " +
			" <ns1:Org_Id></ns1:Org_Id> " +
			" </ns1:RESTHeader> " +
			" <InputParameters> ";
	/**
	 * 拼装erp系统报文结尾  oracle
	 */
   public static final String erp_xml_request_end="<ns:XV_RETURN_STAUTS>2</ns:XV_RETURN_STAUTS> " +
	" <ns:XV_RETURN_MSG>2</ns:XV_RETURN_MSG> " +
	" </InputParameters> " +
	" </Input>";
	
	private static String readHttpResponse(HttpURLConnection conn) {
		InputStream is = null;
		BufferedReader rd = null;
		StringBuffer response = new StringBuffer();
		try {
			if (conn.getResponseCode() >= 400) {
				is = conn.getErrorStream();
			} else {
				is = conn.getInputStream();
			}
			rd = new BufferedReader(new InputStreamReader(is));
			String line;
			while ((line = rd.readLine()) != null) {
				response.append(line);
				response.append('\n');
			}
		} catch (IOException ioe) {
			response.append(ioe.getMessage());
		} finally {
			if (is != null) {
				try {
					is.close();
				} catch (Exception e) {
				}
			}
			if (rd != null) {
				try {
					rd.close();
				} catch (Exception e) {
				}
			}
		}
		return (response.toString());
	}
	
	public static String postXml_BasicAuth(String svcUrlStr, String username, String passwd,String xmlRequest4)
	throws IOException {
		URL url = new URL(svcUrlStr);
		// Obtaining connection to invoke the service
		HttpURLConnection conn = (HttpURLConnection) url.openConnection();
		// Setting Http header values conn.setRequestMethod("POST");
		conn.setRequestProperty("Content-Type", "application/xml");
		String auth = username + ":" + passwd;
		byte[] bytes = Base64.encode(auth).getBytes();
		String authStr = new String(bytes);
		conn.setRequestProperty("Authorization", "Basic " + authStr);
		//conn.setRequestProperty("Accept", "application/xml");
		conn.setRequestProperty("Content-Language", "en-US");
		/** 新增修改**/
		conn.setRequestProperty("Content-Type", "application/xml");
		conn.setRequestProperty("Accept-Charset", "UTF-8");
		conn.setRequestProperty("Accept", "application/xml;charset=utf-8");
		conn.setRequestProperty("SOAPAction","application/soap+xml; charset=utf-8");
		//conn.setRequestProperty("Content-Type","application/x-www-form-urlencoded; charset=UTF-8");
		/** 新增修改**/
		conn.setUseCaches(false);
		conn.setDoInput(true);
		conn.setDoOutput(true);
		// Send request
		OutputStreamWriter wr = new OutputStreamWriter(conn.getOutputStream(),"UTF-8");
		//System.out.println("报文："+xmlRequest4.trim());
		wr.write(xmlRequest4.toCharArray());
		wr.flush();
		wr.close();
		conn.connect();
		//System.out.println("Response code - " + conn.getResponseCode());
		// Get Response
		String response = null;
		try {
			response = readHttpResponse(conn);
		} finally {
			if (conn != null)
				conn.disconnect();
		}
		// Show response
		//System.out.println("Response is : \n" + response);
		return response;
	}
	
	public static String ERPClient(String url,String username,String password,String xmlrequest){
		
		// invoke Rest service using basic authentication method
		
		String returnXml = "";
		try { 
			xmlrequest = xmlrequest.replaceAll("&", "");
			xmlrequest = xmlrequest.replaceAll("（", "");
			xmlrequest = xmlrequest.replaceAll("）", "");
			xmlrequest = xmlrequest.replaceAll("~", "");
			returnXml = postXml_BasicAuth(url, username, password,xmlrequest);
		} catch (IOException e) {
			e.printStackTrace();
		}
		return returnXml;
	}
	
	
	

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		// String baseUrl = "http://yumebstest.risechina.com:8009/webservices/rest/SCUX_TRANSFER/process_transfer/POST/";
		//String baseUrl = "http://yumebstest.risechina.com:8009/webservices/rest/Data_Transfer1/process_transfer/POST/";
		String baseUrl = "http://ebs.risechina.com/webservices/rest/SCUX_TRANSFER/process_transfer/POST/";
		/*StringBuffer sb = new StringBuffer();
		sb.append(InterfaceClientUtil.erp_xml_request_start);

		sb.append("<ns:PV_BUSINESS_TYPE_CODE>COS001</ns:PV_BUSINESS_TYPE_CODE>");//唯一标识
		sb.append("<ns:PN_BATCH_ID>12344</ns:PN_BATCH_ID>");//requestid
		sb.append("<ns:PN_ROW_COUNT_NUM>1</ns:PN_ROW_COUNT_NUM>");//行号
		sb.append("<ns:PC_ROWS>");
		JSONObject  rowdata = new JSONObject();
		JSONObject  msgdata = new JSONObject();
		msgdata.accumulate("INTF_ID", "1");
		msgdata.accumulate("INTF_BATCH_ID", "5");
		msgdata.accumulate("TEST1", "2");
		msgdata.accumulate("TEST2", "3");
		msgdata.accumulate("TEST3", "4");
		rowdata.accumulate("row", msgdata);
		//msgdata.accumulate("rows", value); 
		sb.append(rowdata.toString());
		sb.append("</ns:PC_ROWS>");
		sb.append(InterfaceClientUtil.erp_xml_request_end);*/
		String PN_BATCH_ID = "5823";
		String xml1 = "<Input xmlns:ns=\"http://xmlns.oracle.com/apps/cux/soaprovider/plsql/rest/Scux_Soa_Data_Transfer_Pkg/\"> <ns1:RESTHeader xmlns:ns1=\"http://xmlns.oracle.com/apps/cux/soaprovider/plsql/rest/Scux_Soa_Data_Transfer_Pkg/\">  <ns1:Responsibility>SCUX_INTERFACE_SUPERUSER</ns1:Responsibility>  <ns1:RespApplication>SCUX</ns1:RespApplication> <ns1:SecurityGroup>STANDARD</ns1:SecurityGroup>  <ns1:NLSLanguage>AMERICAN</ns1:NLSLanguage>  <ns1:Org_Id></ns1:Org_Id>  </ns1:RESTHeader>  <InputParameters> <ns:PV_BUSINESS_TYPE_CODE>PORTAL001</ns:PV_BUSINESS_TYPE_CODE><ns:PN_BATCH_ID>"+PN_BATCH_ID+"</ns:PN_BATCH_ID><ns:PN_ROW_COUNT_NUM>2</ns:PN_ROW_COUNT_NUM><ns:PC_ROWS>{\"rows\":[{\"BUSINESS_TYPE_CODE\":\"PORTAL001\",\"PORTAL_FLOW_HEAD_ID\":\"34445\",\"PORTAL_FLOW_LINE_ID\":\"193\",\"PORTAL_FLOW_TYPE\":\"CW05\",\"PORTAL_FLOW_LINE_NUM\":\"\",\"PORTAL_FLOW_NUM\":\"\",\"PORTAL_FLOW_LINE_NUM_REF\":\"\",\"PORTAL_FLOW_LINE_ID_REF\":\"\",\"PORTAL_FLOW_NUM_REF\":\"\",\"EMPLOYEE_NUM\":\"2350\",\"EMPLOYEE_NAME\":\"郑然\",\"EMPLOYEE_DEPT\":\"培训部\",\"APPLY_DATE\":\"2018-12-15\",\"EMPLOYEE_COMPANY_NUM\":\"瑞思中国\",\"BUGET_FLAG\":\"1\",\"PAY_FOR_CENTER\":\"1\",\"FOREIGN_COMPANY_FLAG\":\"1\",\"INVOICE_FLAG\":\"1\",\"CURRENCY_CODE\":\"0\",\"EXCHANGE_RATE\":\"1.00\",\"PAY_METHOD\":\"2\",\"PAY_TYPE\":\"3\",\"ACCOUNTED_AMOUNT\":\"500.00\",\"CONTRACT_CLASS\":\"\",\"CONTRACT_NUM\":\"\",\"CONTRACT_NAME\":\"\",\"CONTRACT_AMOUNT\":\"\",\"PAID_AMOUNT\":\"\",\"UNPAID_AMOUNT\":\"\",\"PAY_AMOUNT_TOTAL\":\"\",\"CONTRACT_START_DATE\":\"\",\"CONTRACT_END_DATE\":\"\",\"PROFIT_START_DATE\":\"\",\"PROFIT_END_DATE\":\"\",\"VENDOR_NUMBER\":\"\",\"VENDOR_NAME\":\"\",\"VENDOR_TAX_NUMBER\":\"\",\"RECEIPT_PERSON\":\"郑然\",\"BANK_ACCOUNT_NAME\":\"郑然\",\"BANK_ACCOUNT_NUM\":\"11101919283237\",\"BANK_NAME\":\"北京西北支行\",\"UNION_BANK_NUM\":\"1231\",\"PAY_MEMO\":\"付款事由\",\"STATUS\":\"NEW\",\"ACCOUNT_TYPE\":\"rise-02-003\",\"PROJECT_CODE\":\"erp011\",\"DEPARTMENT_CODE\":\"erpbm002\",\"SCHOOL_DEPARTMENT_CODE\":\"\",\"COMPANY_CODE\":\"erp001\",\"PAY_AMOUNT\":\"200.00\",\"VAT_TAX_FLAG\":\"0\",\"TOTAL_AMOUNT\":\"200.00\",\"TAX_RATE\":\"1.00\",\"UNTAX_AMOUNT\":\"198.02\",\"TAX_AMOUNT\":\"1.98\",\"INTF_ATTRIBUTE1\":\"formtable_main_72\",\"INTF_ATTRIBUTE2\":\"34445\"},{\"BUSINESS_TYPE_CODE\":\"PORTAL001\",\"PORTAL_FLOW_HEAD_ID\":\"34445\",\"PORTAL_FLOW_LINE_ID\":\"194\",\"PORTAL_FLOW_TYPE\":\"CW05\",\"PORTAL_FLOW_LINE_NUM\":\"\",\"PORTAL_FLOW_NUM\":\"\",\"PORTAL_FLOW_LINE_NUM_REF\":\"\",\"PORTAL_FLOW_LINE_ID_REF\":\"\",\"PORTAL_FLOW_NUM_REF\":\"\",\"EMPLOYEE_NUM\":\"2350\",\"EMPLOYEE_NAME\":\"郑然\",\"EMPLOYEE_DEPT\":\"培训部\",\"APPLY_DATE\":\"2018-12-15\",\"EMPLOYEE_COMPANY_NUM\":\"瑞思中国\",\"BUGET_FLAG\":\"1\",\"PAY_FOR_CENTER\":\"1\",\"FOREIGN_COMPANY_FLAG\":\"1\",\"INVOICE_FLAG\":\"1\",\"CURRENCY_CODE\":\"0\",\"EXCHANGE_RATE\":\"1.00\",\"PAY_METHOD\":\"2\",\"PAY_TYPE\":\"3\",\"ACCOUNTED_AMOUNT\":\"500.00\",\"CONTRACT_CLASS\":\"\",\"CONTRACT_NUM\":\"\",\"CONTRACT_NAME\":\"\",\"CONTRACT_AMOUNT\":\"\",\"PAID_AMOUNT\":\"\",\"UNPAID_AMOUNT\":\"\",\"PAY_AMOUNT_TOTAL\":\"\",\"CONTRACT_START_DATE\":\"\",\"CONTRACT_END_DATE\":\"\",\"PROFIT_START_DATE\":\"\",\"PROFIT_END_DATE\":\"\",\"VENDOR_NUMBER\":\"\",\"VENDOR_NAME\":\"\",\"VENDOR_TAX_NUMBER\":\"\",\"RECEIPT_PERSON\":\"郑然\",\"BANK_ACCOUNT_NAME\":\"郑然\",\"BANK_ACCOUNT_NUM\":\"11101919283237\",\"BANK_NAME\":\"北京西北支行\",\"UNION_BANK_NUM\":\"1231\",\"PAY_MEMO\":\"付款事由\",\"STATUS\":\"NEW\",\"ACCOUNT_TYPE\":\"rise-02-020\",\"PROJECT_CODE\":\"erp011\",\"DEPARTMENT_CODE\":\"erpbm002\",\"SCHOOL_DEPARTMENT_CODE\":\"\",\"COMPANY_CODE\":\"erp001\",\"PAY_AMOUNT\":\"300.00\",\"VAT_TAX_FLAG\":\"0\",\"TOTAL_AMOUNT\":\"300.00\",\"TAX_RATE\":\"2.00\",\"UNTAX_AMOUNT\":\"294.12\",\"TAX_AMOUNT\":\"5.88\",\"INTF_ATTRIBUTE1\":\"formtable_main_72\",\"INTF_ATTRIBUTE2\":\"34445\"}]}</ns:PC_ROWS><ns:XV_RETURN_STAUTS>2</ns:XV_RETURN_STAUTS>  <ns:XV_RETURN_MSG>2</ns:XV_RETURN_MSG>  </InputParameters>  </Input>";
//		String xml = ERPClient(baseUrl, "soa_p", "00000",xml1);
		String xml = ERPClient(baseUrl, "SOA_P", "00000",xml1);
		System.out.println(xml);
		
	}

}
